use std::{any::Any, collections::HashMap};

pub struct Data {
    data: Box<dyn Any>
}

impl From<Box<dyn Any>> for Data {
    fn from(value: Box<dyn Any>) -> Self {
        Self {
            data: value,
        }
    }
}

impl Into<Box<dyn Any>> for Data {
    fn into(self) -> Box<dyn Any> {
        self.data
    }
}

impl From<String> for Data {
    fn from(value: String) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<&str> for Data {
    fn from(value: &str) -> Self {
        Self {
            data: Box::new(value.to_string()),
        }
    }
}

impl From<i8> for Data {
    fn from(value: i8) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<i16> for Data {
    fn from(value: i16) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<i32> for Data {
    fn from(value: i32) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<i64> for Data {
    fn from(value: i64) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<i128> for Data {
    fn from(value: i128) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<u8> for Data {
    fn from(value: u8) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<u16> for Data {
    fn from(value: u16) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<u32> for Data {
    fn from(value: u32) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<u64> for Data {
    fn from(value: u64) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<u128> for Data {
    fn from(value: u128) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<f32> for Data {
    fn from(value: f32) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<f64> for Data {
    fn from(value: f64) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<bool> for Data {
    fn from(value: bool) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<Vec<Data>> for Data {
    fn from(value: Vec<Data>) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}

impl From<HashMap<String, Data>> for Data {
    fn from(value: HashMap<String, Data>) -> Self {
        Self {
            data: Box::new(value),
        }
    }
}
